package com.jkcredit.invoice.util;

import net.sf.json.JSONObject;
import org.apache.commons.httpclient.HttpClient;
import org.apache.commons.httpclient.NameValuePair;
import org.apache.commons.httpclient.methods.PostMethod;

import java.io.*;
import java.util.Iterator;


public class QueryDemo_Test {

	/**
	 * 测试地址
	 */
		private static final String URL = "http://etc.jkcredit.com:9999/api/rest";


	/**
	 * 分配的appKey
	 */

	
		private static final String appKey = "xxxxxx";

	/**
	 * 方法入口
	 *
	 * @param args
	 */
	public static void main(String args[]) throws Exception {
		   QueryDemo_Test demo = new QueryDemo_Test();
		demo.runMainService();
	}

	/**
	 * 调用主接口
	 */
	public void runMainService() {
		try {
			/**
			 * 实名demo
			 */
			JSONObject paramJsonObj = initParamJsonObj_Realname();
			String ret = postClient(URL, paramJsonObj);
			System.out.println(ret);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * 整合参数(实名认证)
	 *
	 * @return
	 */
	public JSONObject initParamJsonObj_Realname() {
		/**
		 * 基本参数
		 */
		JSONObject paramJsonObj = new JSONObject();
		paramJsonObj.put("api", "PROTOCOL_ADD_V1");
		paramJsonObj.put("appKey", appKey);
	    paramJsonObj.put("appSecret",
		"xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx");

	   

		/**
		 * 业务参数
		 */
		JSONObject dataJson = initMainServiceParamJsonObj_Realname();
		paramJsonObj.put("data", dataJson);
		return paramJsonObj;
	}

	/*
	 * 初始化业务参数(实名认证)
	 *
	 * 姓名,身份证,手机号
	 *
	 * @return
	 */
	public JSONObject initMainServiceParamJsonObj_Realname() {
		/**
		 * 具体业务参数放在data中
		 */
		  JSONObject dataJson = new JSONObject();

		  dataJson.put("companyNum", "xxxxxx");
	      dataJson.put("serviceStartTime","2022-05-16T11:30:37");
	      dataJson.put("serviceEndTime","2023-05-16T21:30:37");
	      dataJson.put("contractFileName","xxxxxx测试20220516.pdf");
	      dataJson.put("serviceType","3");
	      dataJson.put("base64Str",Base64Utils.fileToBase64Str(new File("/Users/mashengyi/Desktop/xxxxxx.pdf")));
		  return dataJson;
	}

	/**
	 * 实现http post请求 注意编码 UTF-8
	 *
	 * @param url
	 * @param paramObj
	 * @return
	 */
	public String postClient(String url, JSONObject paramObj) {
		String str = "";
		HttpClient client = null;
		PostMethod method = null;
		try {
			client = new HttpClient();
			method = new PostMethod(url);
			method.setRequestHeader("Content-Type", "application/json;charset=utf-8");
			NameValuePair[] param = new NameValuePair[paramObj.size()];
			@SuppressWarnings("unchecked")
			Iterator<String> keys = paramObj.keys();
			int i = 0;
			while (keys.hasNext()) {
				String key = (String) keys.next();
				String value = paramObj.getString(key);
				param[i] = new NameValuePair(key, value);
				i++;
			}
			method.setRequestBody(param);
			client.executeMethod(method);
			str = convertStreamToString(method.getResponseBodyAsStream());
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (method != null) {
				method.releaseConnection();
			}
		}
		return str;
	}

	/**
	 * 流转字符串
	 *
	 * @param is
	 * @return
	 */
	public static String convertStreamToString(InputStream is) {
		BufferedReader reader = new BufferedReader(new InputStreamReader(is));
		StringBuilder builder = new StringBuilder();
		 String line = null;
		try {
			while ((line = reader.readLine()) != null) {
				builder.append(line + "\n");
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				is.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		return builder.toString();
	}

}
